import java.io.*;
import java.util.Scanner;

public class Fajlovi {
	private static Scanner ulaz; 
	
	void readFromTextFile(String fName){
		
		File f = new File (fName);
		FileReader fr = null; 
		try {
			fr = new FileReader(f);
			ulaz = new Scanner(fr);
			String red = null;
			String ime = null;
			int ind, god, br;
			int [] ocjene;
			Student s = null;
			while (ulaz.hasNextLine()) {
				ime = ulaz.nextLine();
				red = ulaz.nextLine();
				br = red.indexOf(' ');
				ind = Integer.parseInt(red.substring(0, br));
				god = Integer.parseInt(red.substring(br+1));
				br = Integer.parseInt(ulaz.nextLine());
				red = ulaz.nextLine();
				String [] oc = red.split(" ");
				int i = 0; 
				ocjene = new int[oc.length];
				for (String t : oc) {
					ocjene[i] = Integer.parseInt(t);
					i++;
				}
				s = new Student(ime, ind, god, ocjene);
				System.out.println(s.getIme() + " " + s.printIndeks() + " "+ s.getAverage());
			}
			
			if (fr != null) {
				fr.close();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("Fajl ne postoji");
			e.printStackTrace();
		} 
	}
	
	void appendToTextFile(String fName, Student s){
		
		File f = new File (fName);
		FileWriter fw = null;
		BufferedWriter bw = null;
		try {
			if (!f.exists()) {
				f.createNewFile();
			}
			 
			// drugi argument true oznacava append
			// ako nema drugog argumenta, podrazumijeva se brisanje sadrzaja
			fw = new FileWriter(f, true);
			bw = new BufferedWriter(fw);
			bw.write(s.getIme());
			bw.newLine();
			bw.write(s.getIndeks() + " " + s.getGodina());
			bw.newLine();
			bw.write(Integer.toString(s.getOcjene().length));
			bw.newLine();
			StringBuilder o = new StringBuilder();
			for (int i = 0; i< s.getOcjene().length; i++ ) {
				o = o.append(s.getOcjene()[i] + " "); 
			}
			bw.write(o.toString());
			bw.newLine();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		finally {		
				try {
					if (bw!=null) {
						bw.close();
					}
					if (fw !=null) {
						fw.close();
					}
				}
				catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}	
		}

	/*
		Serijalizacija
	*/		
	void fileSerial(String fName, Student s) {
		File f = new File(fName);
		
		FileOutputStream fos = null; 
		ObjectOutputStream out = null;
		try {
			if (!f.exists()) {
				f.createNewFile();
			}
			fos = new FileOutputStream(f, true);
			out = new ObjectOutputStream(fos);
			out.writeObject(s);
			out.writeObject(new Student("Petar Jovic", 12,1016, new int[] {7,8,9}));
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		finally {
			try {
				if (out != null)
				{
					out.close();
				}
				if (fos != null)
				{
					fos.close();
				}
			}
			catch(IOException e) {
				e.printStackTrace();
			}
		} // end of try/catch/finally
	}
	
	// deserijalizacija
	void readFileSerial(String fName) {
		File f = new File(fName);
		
		FileInputStream fos = null; 
		ObjectInputStream out = null;
		try {
			fos = new FileInputStream(f);
			out = new ObjectInputStream(fos);
			Student s = (Student)out.readObject();
			System.out.println(s);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		finally {
			try {
				if (out != null)
				{
					out.close();
				}
				if (fos != null)
				{
					fos.close();
				}
			}
			catch(IOException e) {
				e.printStackTrace();
			}
		} // end of try/catch/finally
	}
}
